#ifndef __SIMWCLASS
#define __SIMWCLASS

#include <qframe.h>
#include <xnet.h>

//laurent
#include <kstatusbar.h>


#define  S_CUR1 12000
#define  S_CUR2 12001


class SimW : public QFrame
{	Q_OBJECT
public:
	SimW(XDeviceNet *);
	~SimW();
	void setSimMode(int);
	XDeviceNet * currentNet();
	void hide();

public slots:
	void simStep();
	void graphChange();
	void changeNet(XDeviceNet *);

signals:
	void shidden();

private:
	static const int MAXY = 100;
	int MINX;
	static const int MAXX = 1024;

	void mousePressEvent( QMouseEvent * );
        void mouseMoveEvent( QMouseEvent * );
	void mouseReleaseEvent(QMouseEvent *);
	void resizeEvent( QResizeEvent * );

	void drawCursor(QPainter *);
        void eraseCursor(QPainter *);

	void paintEvent(QPaintEvent *);
	inline void get();
	inline void draw(QPainter *);
	inline void erase(QPainter *);
	inline void coord(QPainter *);
	inline int transval(int);

	int c1x, c2x, activeC, c1x_old, c2x_old;

	list<XDevice> ldev;
	XDeviceNet *net;

	int xmag;
	int ymag;
	int ymag_d;

	int simmode;
	QPixmap csr_pic;

	KStatusBar *bar;

	char slot[MAXY + 1][MAXX + 100];
	char oslot[MAXY + 1][MAXX + 100];
	int slotcnt;
	int slotwidth;
	char fill1[MAXX + 100];
	char fill0[MAXX + 100];
};

#endif
